// I know, I know, don't declare globals. Well, nurtz. Pathological terror of globals leads to baroque code.

window.mapView;




function loadUserLocation() {
	
	
	// Called from the main Hype document.
		
	if (navigator.geolocation) {
	
		// Try to figure out where the user is. The return passes values to two embedded function calls.
		
		navigator.geolocation.getCurrentPosition(determineLatLong, handleGeolocationError);
				
	} else {
	
		// Skips the location setting entirely and loads a default map view.
		
		setUserLocTo ( -77.841878, 166.686345, "Your browser does not support geolocation; your start location has been set to McMurdo, Antarctica." );
		
	}


}




function determineLatLong ( position ) {

	
	setUserLocTo ( position.coords.latitude, position.coords.longitude, "Location determined!" );


}




function handleGeolocationError ( err ) {


	// If there's anything other than a success code on the geolocation...
	
	var prefix = "";

	switch(err.code) {
		case err.PERMISSION_DENIED:
        	prefix = "For best accuracy, enable location services. "
            break;
        case err.POSITION_UNAVAILABLE:
            prefix = "Location information is unavailable. "
            break;
        case err.TIMEOUT:
        	prefix = "The request to get user location timed out. "
            break;
        case err.UNKNOWN_ERROR:
			prefix = "An unknown error occurred. "
			break;
        }
	
	setUserLocTo ( -77.841878, 166.686345, (prefix + "Defaulting location to McMurdo, Antarctica.") );

	
}




function setUserLocTo ( inputLat, inputLong, feedbackString ) {


	// Default values are the LatLong coords of McMurdo, Antarctica.
	// Why? Well, everyone gotta be someplace.
	
	var userLat = -77.841878;
	var userLong = 166.686345;
	
	if (inputLat != 0) {
	
		userLat = inputLat;
		
	}
	
	if (inputLong != 0) {
	
		userLong = inputLong;
		
	}
	
	// Update the status window under the map view.
	
	statusElem = document.getElementById("googleMapWrapperStatus");
	statusElem.innerHTML = feedbackString;

	// This is part of the reason the mapView variable is global; it's referenced periodically in this script.
	// As such it needs to be much more accessible and addressable than it would be sitting in a single function somewhere.
	
	var userLatLong = new google.maps.LatLng ( userLat, userLong );

	var mapOptions = {
	
						center: { lat: userLat, lng: userLong },
						zoom: 15,
						
					};
					
	mapView = new google.maps.Map ( document.getElementById("map_view"), mapOptions);
	
	// Add a caption to the marker we're about to drop.
	
	var infowindow = new google.maps.InfoWindow ( {
		content: "You are here!"
	});
	
	var marker = new google.maps.Marker ( {
		position: userLatLong,
		map: mapView,
		title: feedbackString,
		
		// Because I really don't like the goofy pointers Google uses.
		// There is a vast number of icon resource libraries out there, but most of them are fugly.
		// So instead, we'll just do a nice simple vector circle.
		
		icon: 	{
				path: 			google.maps.SymbolPath.CIRCLE,
				scale: 			8,
				strokeColor:	"royalBlue",
				strokeWeight:	5,
				fillColor:		"royalBlue",
				fillOpacity:	0.5
				},

	});
	
	// Provide an info popup when the user clicks the map marker.
	
	google.maps.event.addListener ( marker, "click", function() {
		infowindow.open ( mapView, marker );
	});


}



